'''
Created October 25, 2022
'''
import unittest

def is_prime(p):
    '''
    Test if a given integer p is prime or not.

    **Parameters**

        p: *int*
            Some number to test.

    **Returns**

        chk: *bool*
            Whether p is prime (True) or not (False).
    '''
    if p <= 0:
        return False

    small_primes = [1, 2, 3, 5, 7]
    if p in small_primes:
        return True

    for i in range(2, int((p**0.5))+1):
        if p%i==0:
            return False

    return True

class TestIsPrime(unittest.TestCase):
    '''
    Testing suite for is_prime function.
    '''

    def test_1(self):
        self.assertFalse(is_prime(1))

    def test_2(self):
        self.assertTrue(is_prime(2))

    def test_3(self):
        self.assertEqual(is_prime(22341352), False)

    def test_bad_type(self):
        data = "oops"
        with self.assertRaises(TypeError):
            result = is_prime(data)

if __name__ == "__main__":
    unittest.main()

